/* GtkTetcolor
 * Copyright (C) 1999 Andrey V. Panov
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#define X_SIZE 7
#define Y_SIZE 18
#define NUMBER_COLORS 7
#define NUMBER_TYPES 4
#define INI_INTERVAL 1000
#define LEVEL_INT 1000
#define MIN_SCORE 40
#define border 2
#define MAX_CELL_SIZE 50

struct
{
  gint num;
  gint type;
  gint color[3];
  gint x[3];
  gint y[3];
}
block;

gboolean new_block (GtkWidget * widget);
gint cell_state[X_SIZE][Y_SIZE];
gint cell_state_wo_block[X_SIZE][Y_SIZE];
gint cell_state_prev[X_SIZE][Y_SIZE];
gint removing_cell[X_SIZE][Y_SIZE];
gint lines, score, bonus, saved_score[10], continue_game;
gint bonus_tic;
gchar name[10][256], new_name[256];
guint32 interval;
gint timeout, level, level_tic, level_timeout;

void init_game (GtkWidget * widget);

gboolean redraw_cells (GtkWidget * widget);

gboolean redraw_all_cells (GtkWidget * widget);

void game_over (GtkWidget * widget);

GtkFunction timeout_callback (GtkWidget * main_window);

gboolean rotate_cell_right (gint i, gint * newx, gint * newy);

gboolean rotate_cell_left (gint i, gint * newx, gint * newy);

void change_rotated_cell (gint i, gint newx, gint newy);

GtkFunction change_level (GtkWidget * window);

void check_lines (GtkWidget * widget);

gboolean seek_removing_cells (void);

gboolean remove_cells (void);

GtkFunction stop_delay (void);

gint delay_moving (void);

gboolean create_pixmaps (GtkWidget * widget, gint first_time);

void load_preferences (void);

gboolean rotate_block (gboolean (*rotate_cell)(gint i, gint *newx, gint *newy));

gboolean shift_block (gint direction);
